unit Score;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  TScore = class (TLabel)                                                       // Komponente TScore mit Komponente TLabel
    private                                                                     //
      EOnChange: TNotifyEvent;                                                  // Das Event OnChange
      Vname: string;                                                            // Variable Vorname
      Stand: integer;                                                           // Variable Anzahl Punkte im Score
      Standalt: integer;                                                        // Variable letzter Stand von Variable Stand
      procedure SetOnChange(AValue: TNotifyEvent);                              // Laden Event in FOnChange
    public
      constructor Create(AOwner: TComponent; Besitzer: TForm; Vorname: string); reintroduce;  // ertellen Komponente TScore
      destructor Destroy; override;                                             // zerstören Komponente TScore
      procedure erhoehen(Wert: integer);                                        // erhöht den Wert von Stand um Wert
      Property OnChange:TNotifyEvent read EOnChange write SetOnChange;          // Das Ereignis OnChange
      function getName: string;                                                 // gibt den Vornamen zurück
      function getStand: integer;                                               // gibt den Stand zurück
  end;

procedure Register;

implementation

procedure Register;
begin
  {$I score_icon.lrs}
  RegisterComponents('aExample',[TScore]);
end;
constructor TScore.Create(AOwner: TComponent; Besitzer: TForm; Vorname: string);
begin
  inherited Create(AOwner);
  Parent:=Besitzer;
  Alignment:=taCenter;
  Autosize:=False;
  Color:=clNavy;
  Font.Color:=clYellow;
  Font.Name:='Arial Black';
  Font.Size:=16;
  Font.Style:=[fsBold];
  Height:=32;
  Left:=10;
  Top:=100;
  Transparent:=False;
  Visible:=True;
  Width:=962;
  Vname:=Vorname;
  Stand:=0;
  Standalt:=0;
end;

{
  Procedure Destroy
      zerstört die Komponente TScore.
  Eingabefelder = keine
  Ausgabefelder = keine
}
destructor TScore.Destroy;
begin
  inherited Destroy;
end;

// Laden Event in FOnChange
{
  Procedure SetOnChange
      läd AValue in Variable FOnChange.
  Eingabefelder = AValue (Variable EOnChange)
  Ausgabefelder = keine
}
procedure TScore.SetOnChange(AValue: TNotifyEvent);
begin
  if EOnChange=AValue then Exit;
  EOnChange:=AValue;
end;

{
  Procedure ergoehen
      erhöht die Variable Stand um Wert
      und wenn alter Stand ungleich Stand wird das
      Ereignis OnChange ausgelöst.
  Eingabefelder = Wert (Wert der Erhöhung)
  Ausgabefelder = keine
}
procedure TScore.erhoehen(Wert: integer);
begin
  Stand:=Stand+Wert;
  if Stand <> Standalt then
  begin
    If Assigned(EOnChange) Then EOnChange(Self);                                // Event auslösen
    Standalt:=Stand;
  end;
end;

{
  Procedure getName
      gibt den Vornamen zurück.
  Eingabefelder = keine
  Ausgabefelder = keine
}
function TScore.getName: string;
begin
  Result:=Vname;
end;

{
  Procedure getStand
      gibt den Score (Stand) zurück.
  Eingabefelder = keine
  Ausgabefelder = keine
}
function TScore.getStand: integer;
begin
  Result:=Stand;
end;

end.

